#include <stdio.h>

/*
 * ... etwas ausfuehrlicher als ip.c aus der Vorlesung ... ;-)
 */

/*
 * Umwandeln einer IP-Adresse in Form eines Strings in
 * eine Integer
 */
int ipToInt(char *s) {
	int a, b, c, d;

	/*
	 * sscanf liest statt von stdin aus einem
	 * String (hier: s)
	 *
	 * wir lesen einfach die 4 Bytes ein
	 */
	sscanf(s, "%d.%d.%d.%d", &a, &b, &c, &d);

	/*
	 * ... und bauen uns die Integer zusammen.
	 * Byte eins um 24 Bits nach links schieben,
	 * das zweite Byte um 16 Bits nach links schieben,
	 * das dritte um 8 Bits nach links schieben und
	 * alles zusammen mit dem vierten Byte "ver-ODERn"
	 *
	 * "Layout" der Integer:
	 *
	 *        2^24     2^16     2^8      2^0
	 * ........|........|........|........
	 *     a        b        c        d
	 */
	return (a << 24) | (b << 16) | (c << 8) | d;
}

/*
 * IP-Adresse in Integer-Form ausgeben
 * (schoen formatiert)
 */
void printIp(int ip) {
	int a, b, c, d;

	/*
	 * die hintersten 8 Bits enthalten das letzte Byte
	 */
	d = ip & 0xff;
	/*
	 * danach ip um 8 Bits nach rechts schieben ...
	 */
	ip >>= 8;

	/*
	 * die hintersten 8 Bits enthalten NUN das vorletzte Byte
	 */
	c = ip & 0xff;
	/*
	 * danach ip um 8 Bits nach rechts schieben ...
	 */
	ip >>= 8;

	/* usw. .... */
	b = ip & 0xff;
	ip >>= 8;
	a = ip & 0xff;

	/*
	 * nun haben wir die IP-Adresse und koennen sie
	 * schoen formatiert ausgeben
	 */
	printf("%d.%d.%d.%d\n", a, b, c, d);
}

int main() {
	int ip;

	/*
	 * IP-Adress-String in Integer konvertieren
	 */
	ip = ipToInt("134.60.66.5");

	/*
	 * Integer ausgeben
	 */
	printf("ip = %8x\n", ip);

	/*
	 * IP-Adresse aus Integer rueckgewinnen und ausgeben
	 */
	printIp(ip);
	
	return 0;
}
